<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<title>Flow</title>
    <script src="https://cdn.jsdelivr.net/npm/d3-array@3"></script>
    <script src="https://cdn.jsdelivr.net/npm/d3-color@3"></script>
    <script src="https://cdn.jsdelivr.net/npm/d3-format@3"></script>
    <script src="https://cdn.jsdelivr.net/npm/d3-interpolate@3"></script>
    <script src="https://cdn.jsdelivr.net/npm/d3-time@3"></script>
    <script src="https://cdn.jsdelivr.net/npm/d3-time-format@4"></script>
    <script src="https://cdn.jsdelivr.net/npm/d3-scale@4"></script>
    <script src="https://cdn.jsdelivr.net/npm/d3-selection@3"></script>
    <script src="https://cdn.jsdelivr.net/npm/d3-axis@3"></script>
    <script src="https://huww98.github.io/TimeChart/dist/timechart.min.js"></script>
		<style>
			body { margin: 0; }
      #chart { width: 100%; height: 480px; }
		</style>
	</head>
	<body>
    <h1>Trad</h1>
    <div id="chart"></div>
    <script>
        const el = document.getElementById('chart');
        const data = {
          'ct': [],
          'cl': [],
          'du': [],
        };
        const baseTime = Date.now();
        const chart = new TimeChart(el, {
            baseTime: baseTime,
            series: [
              {
                data: data['cl'],
                name: 'CPU L',
                color: 'red',
                lineWidth: 1,
              },
              {
                data: data['ct'],
                name: 'CPU T',
                color: 'green',
                lineWidth: 1,
              },
              {
                data: data['du'],
                name: 'Disk Usage',
                color: 'blue',
                lineWidth: 1,
              },
            ],
            realTime: true,
            xRange: { min: baseTime, max: baseTime + 60000 },
            zoom: {
                x: {
                    autoRange: true,
                },
                y: {
                    autoRange: true,
                }
            },
            tooltip: true,
        });
        const ws = new WebSocket("ws://{{host_ip}}:8000/live");
        ws.onmessage = function(event) {
            const d = JSON.parse(event.data);
            let x = d.ts * 1000 - baseTime;
            data['ct'].push({x, y: d.ct});
            data['cl'].push({x, y: d.cl * 100});
            data['du'].push({x, y: d.du});
            chart.update();
        };
        window.onbeforeunload = function() {
          ws.onclose = function () {};
          ws.close();
        };
    </script>
	</body>
</html>
